// =========================================== M E K A N A L M A   S C R I P T I ==============================================

/* 
    Basic Property System by sseebbyy
        (with pickup model changing)
*/

const NO_OWNER_MSG = "no owner";
const NO_SHARING_MSG = "not shared";
const NO_DESCRIPTION_MSG = "No description yet.";
const NO_PROP_OWNED = "no property owned.";
const NO_PROP_SHARED = "no property shared.";

const PROPS_LOCATION = "Properties.db";
const PROPS_LIMIT = 40;
const PROP_MODEL_FORSALE = 407;
const PROP_MODEL_BOUGHT = 406;

const PROP_CREATE = 1;
const PROP_RELOAD = 2;
const PROP_UPDATE = 3;

const RGB_BLUE = "[#37a2ef]";
const RGB_GREY = "[#e0e0e0]";

//-------------------------------------------------------------

class Property
{
    ID = null;
    Name = null;
    Price = null;
    Owner = null;
    Sharing = null;
    Description = null;
    x = null;
    y = null;
    z = null;
    World = null;
}

//-------------------------------------------------------------

    prop <- array( PROPS_LIMIT, null );
    lastPickupPickedUp <- array( GetMaxPlayers(), null )
    _srv_Properties <- 0;
    
    dbProperties <- ConnectSQL( PROPS_LOCATION );
    QuerySQL ( dbProperties, "CREATE TABLE IF NOT EXISTS Properties ( ID INT, Name TEXT, Price INT, Owner TEXT, Sharing TEXT, Description TEXT, x FLOAT, y FLOAT, z FLOAT, World INT )" );

    print( "Basic Property System was loaded." );
    
//-------------------------------------------------------------
    
function pMSG( text, player )
{
    return MessagePlayer( RGB_BLUE + text.tostring(), player );
}

function UpdateProperty( id, name, price, owner, sharing, description, x, y, z, world )
{
    local see_dbProperties = QuerySQL ( dbProperties, "SELECT * FROM sqlite_master WHERE type='table' AND name='Properties'" );
    if( !see_dbProperties ) return print( "[dbProps] There are no properties." );
    else FreeSQLQuery( see_dbProperties );

        QuerySQL( dbProperties,
            format(@"UPDATE [Properties] SET
                [ID]=%i,
                [Price]=%i,
                [Owner]='%s',
                [Sharing]='%s',
                [Description]='%s',
                [x]=%f,
                [y]=%f,
                [z]=%f,
                [World]=%i
                WHERE [Name]='%s';",
                prop[ id ].ID.tointeger(), price.tointeger(), owner.tostring(), sharing.tostring(), description.tostring(), x.tofloat(), y.tofloat(), z.tofloat(), world.tointeger(),
                name.tostring()
            )
        );
                
                prop[ id ].ID = prop[ id ].ID;
                prop[ id ].Name = name;
                prop[ id ].Price = price;
                prop[ id ].Owner = owner;
                prop[ id ].Sharing = sharing;
                prop[ id ].Description = description;
                prop[ id ].x = x;
                prop[ id ].y = y;
                prop[ id ].z = z;
                prop[ id ].World = world;
}

function CreateProperty( name, price, x, y, z, world )
{
    local see_dbProperties = QuerySQL ( dbProperties, "SELECT * FROM sqlite_master WHERE type='table' AND name='Properties'" );
    if( !see_dbProperties ) return print( "[dbProps] There are no properties." );
    else FreeSQLQuery( see_dbProperties );
    
        local p = CreatePickup( PROP_MODEL_FORSALE, world, 0, x, y, z, 255, true );
        if( p )
        {
            prop[ p.ID ] = null;
            prop[ p.ID ] = Property(); // important
            prop[ p.ID ].ID = _srv_Properties;
            prop[ p.ID ].Name = name;
            prop[ p.ID ].Price = price;
            prop[ p.ID ].Owner = NO_OWNER_MSG;
            prop[ p.ID ].Sharing = NO_SHARING_MSG;
            prop[ p.ID ].Description = NO_DESCRIPTION_MSG;
            prop[ p.ID ].x = x;
            prop[ p.ID ].y = y;
            prop[ p.ID ].z = z;
            prop[ p.ID ].World = world;
            
            local   query = format( "INSERT INTO Properties ( ID, Name, Price, Owner, Sharing, Description, x, y, z, World ) VALUES ( %i, '%s', %i, '%s', '%s', '%s', %f, %f, %f, %i )", 
                        _srv_Properties, name, price, NO_OWNER_MSG, NO_SHARING_MSG, NO_DESCRIPTION_MSG, x, y, z, world );
                        
            QuerySQL( dbProperties, query );
            
            _srv_Properties += 1;
        }
}

function ReloadProperty( property, model )
{
    if( typeof( property ) == "instance" )
    {
        local   pid = property.ID,
                dbpid = prop[ pid ].ID,
                name = prop[ pid ].Name,
                see_dbProperties = QuerySQL ( dbProperties, "SELECT * FROM sqlite_master WHERE type='table' AND name='Properties'" );
                
        if( !see_dbProperties ) return print( "[dbProps] There are no properties." );
        else FreeSQLQuery( see_dbProperties );

        local listQuery = QuerySQL ( dbProperties, "SELECT * FROM 'Properties' WHERE Name='" + escapeSQLString( name ) + "'" );
        if( listQuery )
        {
                FindPickup( pid ).Remove();
                prop[ pid ] = null;
            
            local p = CreatePickup( model, GetSQLColumnData( listQuery, 9), 0, GetSQLColumnData( listQuery, 6 ), GetSQLColumnData( listQuery, 7 ), GetSQLColumnData( listQuery, 8 ), 255, true );
            if( p )
            {
                local id = p.ID;
                prop[ id ] = null;
                prop[ id ] = Property(); // important
                prop[ id ].ID = dbpid;
                prop[ id ].Name = GetSQLColumnData( listQuery, 1 );
                prop[ id ].Price = GetSQLColumnData( listQuery, 2 );
                prop[ id ].Owner = GetSQLColumnData( listQuery, 3 );
                prop[ id ].Sharing = GetSQLColumnData( listQuery, 4 );
                prop[ id ].Description = GetSQLColumnData( listQuery, 5 );
                prop[ id ].x = GetSQLColumnData( listQuery, 6 );
                prop[ id ].y = GetSQLColumnData( listQuery, 7 );
                prop[ id ].z = GetSQLColumnData( listQuery, 8 );
                prop[ id ].World = GetSQLColumnData( listQuery, 9 );
            }
            
            FreeSQLQuery( listQuery );
        }
    }
}

function RemoveProperty( property )
{
    if( typeof( property ) == "instance" )
    {
        local   id = property.ID,
                dbid = prop[ id ].ID,
                name = prop[ id ].Name,
                see_dbProperties = QuerySQL ( dbProperties, "SELECT * FROM sqlite_master WHERE type='table' AND name='Properties'" );
        
        if( !see_dbProperties ) return print( "[dbProps] There are no properties to load." );
        else FreeSQLQuery( see_dbProperties );
        
        local listQuery = QuerySQL ( dbProperties, "SELECT * FROM 'Properties' WHERE Name='" + escapeSQLString( name ) + "'" );
        if( listQuery )
        {
            FindPickup( id ).Remove();
            prop[ id ] = null;
            
            QuerySQL( dbProperties, "DELETE FROM 'Properties' WHERE Name='" + name + "'" );
            FreeSQLQuery( listQuery );
        }
    }
}

function OwnedProperties( player )
{
    if( FindPlayer( player.ID ) )
    {
        local see_dbProperties = QuerySQL ( dbProperties, "SELECT * FROM sqlite_master WHERE type='table' AND name='Properties'" );
        if( !see_dbProperties ) return print( "[dbProps] There are no properties to load." );
        else FreeSQLQuery( see_dbProperties );
        
        local listQuery = QuerySQL ( dbProperties, "SELECT * FROM 'Properties' WHERE Owner='" + escapeSQLString( player.Name ) + "'" );
        if( listQuery )
        {
            local res = "";
            while( GetSQLColumnData( listQuery, 1 ) )
            {   
                res += GetSQLColumnData( listQuery, 1 ) + ", ";
                GetSQLNextRow( listQuery );
            }
            FreeSQLQuery( listQuery );
            res = res.slice( 0, res.len() - 2 );
            return res;
        } 
        else return NO_PROP_OWNED;
    }
}

function SharedProperties( player )
{
    if( FindPlayer( player.ID ) )
    {
        local see_dbProperties = QuerySQL ( dbProperties, "SELECT * FROM sqlite_master WHERE type='table' AND name='Properties'" );
        if( !see_dbProperties ) return print( "[dbProps] There are no properties to load." );
        else FreeSQLQuery( see_dbProperties );
        
        local listQuery = QuerySQL ( dbProperties, "SELECT * FROM 'Properties' WHERE Sharing='" + escapeSQLString( player.Name ) + "'" );
        if( listQuery )
        {
            local res = "";
            while( GetSQLColumnData( listQuery, 1 ) )
            {   
                res += GetSQLColumnData( listQuery, 1 ) + ", ";
                GetSQLNextRow( listQuery );
            }
            FreeSQLQuery( listQuery );
            res = res.slice( 0, res.len() - 2 );
            return res;
        } 
        else return NO_PROP_SHARED;
    }
}

function LoadProperties( )
{
    print( "[dbProps] Loading properties..." );
    local modelid, listQuery = QuerySQL ( dbProperties, "SELECT * FROM 'Properties'" );
    if( listQuery )
    {
        while( GetSQLColumnData( listQuery, 1 ) )
        {
            modelid = PROP_MODEL_FORSALE;
            if( GetSQLColumnData( listQuery, 3 ) != NO_OWNER_MSG ) modelid = PROP_MODEL_BOUGHT;
            local p = CreatePickup( modelid, GetSQLColumnData( listQuery, 9), 0, GetSQLColumnData( listQuery, 6 ), GetSQLColumnData( listQuery, 7 ), GetSQLColumnData( listQuery, 8 ), 255, true );
            if( p )
            {
                local count = _srv_Properties;
                
                prop[ count ] = Property(); // important
                prop[ count ].ID = p.ID;
                prop[ count ].Name = GetSQLColumnData( listQuery, 1 ).tostring();
                prop[ count ].Price = GetSQLColumnData( listQuery, 2 ).tointeger();
                prop[ count ].Owner = GetSQLColumnData( listQuery, 3 ).tostring();
                prop[ count ].Sharing = GetSQLColumnData( listQuery, 4 ).tostring(),
                prop[ count ].Description = GetSQLColumnData( listQuery, 5 ).tostring();
                prop[ count ].x = GetSQLColumnData( listQuery, 6 ).tofloat();
                prop[ count ].y = GetSQLColumnData( listQuery, 7 ).tofloat();
                prop[ count ].z = GetSQLColumnData( listQuery, 8 ).tofloat();
                prop[ count ].World = GetSQLColumnData( listQuery, 9 ).tointeger();
                _srv_Properties += 1;
            } 
            else print( "[dbProps] Couldn't load property with name: " + GetSQLColumnData( listQuery, 1 ) );
            GetSQLNextRow( listQuery );
        }
    }
    
    print( "[dbProps] " + _srv_Properties + " properties have been loaded from the database." );
}